# Streambased

The Streambased folks have a great tutorial [on their website](https://www.streambased.io/tutorial-guides/warpstream) on integrating WarpStream with command line Streambased. What follows is a description of using their Analytics Service for Kafka {A.S.K.) product, which is free and requires no downloads or setup. A video walkthrough can be found below.

{% embed url="<https://youtu.be/Z7CZ2WPGbdU>" %}

### Step 1: Create a topic in your WarpStream cluster <a href="#step-1-create-a-topic-in-your-warpstream-cluster" id="step-1-create-a-topic-in-your-warpstream-cluster"></a>

Obtain the Bootstrap Broker from the WarpStream console by navigating to your cluster and clicking the Connect tab. If you don't have SASL credentials yet, you must also [create a set of credentials](https://docs.warpstream.com/warpstream/configuration/enable-agent-auth#sasl-authentication) from the console by clicking on the Credentials tab.

Save these three values, as you will need them in the `sasl.jaas.config` parameter in the next step.

### Step 2: Create your SQL connection string <a href="#step-1-create-a-topic-in-your-warpstream-cluster" id="step-1-create-a-topic-in-your-warpstream-cluster"></a>

Once you have constructed this connection string, it can be executed in a query or BI tool of your choice to establish the connection to your WarpStream cluster. From that point, you can interact with your stream like any other SQL-compatible data source.

The `saasl.jaas.config` has a bit of a gotcha in that the single quote has to be escaped. Streambased has [provided a tool](https://www.streambased.io/getting-started) to format your information to ensure correctness properly.

```yaml
SET SESSION streambased_connection='{
"bootstrap.servers":"YOUR_BOOTSTRAP_BROKER>",
"security.protocol":"SASL_SSL",
"sasl.jaas.config":"org.apache.kafka.common.security.plain.PlainLoginModule required username=''<YOUR_SASL_USERNAME>'' password=''<YOUR_SASL_PASSWORD>'';",
"sasl.mechanism":"PLAIN",
"schema.registry.url":"<SCHEMA_REGISTRY_ENDPOINT_URL>",
"basic.auth.credentials.source":"USER_INFO",
"basic.auth.user.info":"<SCHEMA_REGISTRY_KEY>:<SCHEMA_REGISTRY_SECRET>"
}';
```

### Next Steps <a href="#next-steps" id="next-steps"></a>

Using the above configured SET SESSION command, you now have everything you need to connect with the SQL or BI tool of your choice to query your WarpStream producer stream.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.warpstream.com/warpstream/reference/integrations/streambased.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
